/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
ldse@hendriklipka.de
*/

package de.hendriklipka.ldse.common;

import java.util.Vector;

public class Timer extends Thread
{
  protected long Ticks=0;
  protected long correctedTicks=0;
  
  static Object waitObject=new Object();
  
  public Timer (long ticks)
  {
    Ticks=ticks;
    setDaemon(true);
  }
  
  public void run()
  {
    setPriority(Thread.MAX_PRIORITY);
    correctedTicks=Ticks;
    Object o=new Object();
    while (true)
    {
      synchronized (o)
      {
        long startTime=System.currentTimeMillis();
        try
        {
          o.wait(correctedTicks);
        }
        catch (InterruptedException ex) {}
        try
        {
          waitObject.notifyAll();
        }
        catch (Exception ex) {}
        long endTime=System.currentTimeMillis();
        long d=Ticks-(endTime-startTime);
        correctedTicks+=d;
        // wenn negative Zeiten rauskommen, auf positive Ticks hochrechnen
        // kann passieren, wenn Zielthread das Wait-Object nicht freigibt
        while (1>correctedTicks)
        {
          correctedTicks+=Ticks;
        }
      }
    }
  }

  public static void waitForTick()
  {
    synchronized (waitObject)
    {
      try
      {
        waitObject.wait();
      }
      catch (InterruptedException ex) {}
    }
  }
}